"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_1 = require("../lib/http");
class NowAdapter {
    constructor(config) {
        this.config = config;
        this.client = http_1.HTTP.create({
            baseURL: this.config.instanceUrl,
            timeout: 15000,
            headers: this.config.headers
        });
    }
    static init(config) {
        return new NowAdapter(config);
    }
    set(value, path) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let payload = yield this.client.post('', {
                    params: { path: JSON.stringify(path) },
                    data: value
                });
                return payload.data;
            }
            catch (err) {
                throw err;
            }
        });
    }
    update(value, path) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let payload = yield this.client.put('', {
                    params: { path: JSON.stringify(path) },
                    data: value
                });
                return payload.data;
            }
            catch (err) {
                throw err;
            }
        });
    }
    get(path) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let payload = yield this.client.get('', {
                    params: { path: JSON.stringify(path) }
                });
                return payload.data;
            }
            catch (err) {
                throw err;
            }
        });
    }
    remove(path) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let payload = yield this.client.delete('', {
                    params: { path: JSON.stringify(path) }
                });
                return payload.data;
            }
            catch (err) {
                throw err;
            }
        });
    }
}
exports.NowAdapter = NowAdapter;
//# sourceMappingURL=now.js.map